// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.28.0
// 	protoc        v3.17.3
// source: yandex/cloud/billing/v1/sku.proto

package billing

import (
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// Type of the pricing version.
type PricingVersionType int32

const (
	PricingVersionType_PRICING_VERSION_TYPE_UNSPECIFIED PricingVersionType = 0
	// Regular price.
	PricingVersionType_STREET_PRICE PricingVersionType = 1
	// Price is overridden by a contract. Defined in the scope of a billing account.
	PricingVersionType_CONTRACT_PRICE PricingVersionType = 2
)

// Enum value maps for PricingVersionType.
var (
	PricingVersionType_name = map[int32]string{
		0: "PRICING_VERSION_TYPE_UNSPECIFIED",
		1: "STREET_PRICE",
		2: "CONTRACT_PRICE",
	}
	PricingVersionType_value = map[string]int32{
		"PRICING_VERSION_TYPE_UNSPECIFIED": 0,
		"STREET_PRICE":                     1,
		"CONTRACT_PRICE":                   2,
	}
)

func (x PricingVersionType) Enum() *PricingVersionType {
	p := new(PricingVersionType)
	*p = x
	return p
}

func (x PricingVersionType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (PricingVersionType) Descriptor() protoreflect.EnumDescriptor {
	return file_yandex_cloud_billing_v1_sku_proto_enumTypes[0].Descriptor()
}

func (PricingVersionType) Type() protoreflect.EnumType {
	return &file_yandex_cloud_billing_v1_sku_proto_enumTypes[0]
}

func (x PricingVersionType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use PricingVersionType.Descriptor instead.
func (PricingVersionType) EnumDescriptor() ([]byte, []int) {
	return file_yandex_cloud_billing_v1_sku_proto_rawDescGZIP(), []int{0}
}

// A Stock keeping unit resource.
type Sku struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// ID of the SKU.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// Name of the SKU.
	Name string `protobuf:"bytes,2,opt,name=name,proto3" json:"name,omitempty"`
	// Description of the sku.
	Description string `protobuf:"bytes,3,opt,name=description,proto3" json:"description,omitempty"`
	// ID of the service that sku belongs to.
	ServiceId string `protobuf:"bytes,4,opt,name=service_id,json=serviceId,proto3" json:"service_id,omitempty"`
	// Pricing unit of the SKU, e.g. `core*hour`, `gbyte*hour`.
	PricingUnit string `protobuf:"bytes,5,opt,name=pricing_unit,json=pricingUnit,proto3" json:"pricing_unit,omitempty"`
	// List of pricing versions.
	PricingVersions []*PricingVersion `protobuf:"bytes,6,rep,name=pricing_versions,json=pricingVersions,proto3" json:"pricing_versions,omitempty"`
}

func (x *Sku) Reset() {
	*x = Sku{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Sku) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Sku) ProtoMessage() {}

func (x *Sku) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Sku.ProtoReflect.Descriptor instead.
func (*Sku) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_billing_v1_sku_proto_rawDescGZIP(), []int{0}
}

func (x *Sku) GetId() string {
	if x != nil {
		return x.Id
	}
	return ""
}

func (x *Sku) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *Sku) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

func (x *Sku) GetServiceId() string {
	if x != nil {
		return x.ServiceId
	}
	return ""
}

func (x *Sku) GetPricingUnit() string {
	if x != nil {
		return x.PricingUnit
	}
	return ""
}

func (x *Sku) GetPricingVersions() []*PricingVersion {
	if x != nil {
		return x.PricingVersions
	}
	return nil
}

// Pricing version of the SKU.
// Defines current and past prices for the sku.
type PricingVersion struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Type of the pricing version.
	Type PricingVersionType `protobuf:"varint,1,opt,name=type,proto3,enum=yandex.cloud.billing.v1.PricingVersionType" json:"type,omitempty"`
	// Timestamp pricing version is active since inclusive.
	// The pricing version is active until next pricing version effective time exclusive.
	EffectiveTime *timestamppb.Timestamp `protobuf:"bytes,2,opt,name=effective_time,json=effectiveTime,proto3" json:"effective_time,omitempty"`
	// List of pricing expressions.
	PricingExpressions []*PricingExpression `protobuf:"bytes,3,rep,name=pricing_expressions,json=pricingExpressions,proto3" json:"pricing_expressions,omitempty"`
}

func (x *PricingVersion) Reset() {
	*x = PricingVersion{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PricingVersion) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PricingVersion) ProtoMessage() {}

func (x *PricingVersion) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PricingVersion.ProtoReflect.Descriptor instead.
func (*PricingVersion) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_billing_v1_sku_proto_rawDescGZIP(), []int{1}
}

func (x *PricingVersion) GetType() PricingVersionType {
	if x != nil {
		return x.Type
	}
	return PricingVersionType_PRICING_VERSION_TYPE_UNSPECIFIED
}

func (x *PricingVersion) GetEffectiveTime() *timestamppb.Timestamp {
	if x != nil {
		return x.EffectiveTime
	}
	return nil
}

func (x *PricingVersion) GetPricingExpressions() []*PricingExpression {
	if x != nil {
		return x.PricingExpressions
	}
	return nil
}

// Pricing expression of the pricing version.
// Defines price for the sku.
type PricingExpression struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// List of rates.
	Rates []*Rate `protobuf:"bytes,2,rep,name=rates,proto3" json:"rates,omitempty"`
}

func (x *PricingExpression) Reset() {
	*x = PricingExpression{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[2]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PricingExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PricingExpression) ProtoMessage() {}

func (x *PricingExpression) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[2]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PricingExpression.ProtoReflect.Descriptor instead.
func (*PricingExpression) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_billing_v1_sku_proto_rawDescGZIP(), []int{2}
}

func (x *PricingExpression) GetRates() []*Rate {
	if x != nil {
		return x.Rates
	}
	return nil
}

// Rate of the pricing expression.
// Define unit price for pricing quantity interval.
type Rate struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Start of the pricing quantity interval. The end of the interval is the start pricing quantity of the next rate.
	StartPricingQuantity string `protobuf:"bytes,1,opt,name=start_pricing_quantity,json=startPricingQuantity,proto3" json:"start_pricing_quantity,omitempty"`
	// Unit price for the pricing quantity interval.
	UnitPrice string `protobuf:"bytes,2,opt,name=unit_price,json=unitPrice,proto3" json:"unit_price,omitempty"`
	// Currency of the unit price.
	// Can be one of the following:
	// * `RUB`
	// * `USD`
	// * `KZT`
	Currency string `protobuf:"bytes,3,opt,name=currency,proto3" json:"currency,omitempty"`
}

func (x *Rate) Reset() {
	*x = Rate{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[3]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Rate) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Rate) ProtoMessage() {}

func (x *Rate) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_billing_v1_sku_proto_msgTypes[3]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Rate.ProtoReflect.Descriptor instead.
func (*Rate) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_billing_v1_sku_proto_rawDescGZIP(), []int{3}
}

func (x *Rate) GetStartPricingQuantity() string {
	if x != nil {
		return x.StartPricingQuantity
	}
	return ""
}

func (x *Rate) GetUnitPrice() string {
	if x != nil {
		return x.UnitPrice
	}
	return ""
}

func (x *Rate) GetCurrency() string {
	if x != nil {
		return x.Currency
	}
	return ""
}

var File_yandex_cloud_billing_v1_sku_proto protoreflect.FileDescriptor

var file_yandex_cloud_billing_v1_sku_proto_rawDesc = []byte{
	0x0a, 0x21, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x62,
	0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x2f, 0x76, 0x31, 0x2f, 0x73, 0x6b, 0x75, 0x2e, 0x70, 0x72,
	0x6f, 0x74, 0x6f, 0x12, 0x17, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75,
	0x64, 0x2e, 0x62, 0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x2e, 0x76, 0x31, 0x1a, 0x1f, 0x67, 0x6f,
	0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2f, 0x74, 0x69,
	0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0xe1, 0x01,
	0x0a, 0x03, 0x53, 0x6b, 0x75, 0x12, 0x0e, 0x0a, 0x02, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28,
	0x09, 0x52, 0x02, 0x69, 0x64, 0x12, 0x12, 0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73,
	0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b,
	0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x1d, 0x0a, 0x0a, 0x73,
	0x65, 0x72, 0x76, 0x69, 0x63, 0x65, 0x5f, 0x69, 0x64, 0x18, 0x04, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x09, 0x73, 0x65, 0x72, 0x76, 0x69, 0x63, 0x65, 0x49, 0x64, 0x12, 0x21, 0x0a, 0x0c, 0x70, 0x72,
	0x69, 0x63, 0x69, 0x6e, 0x67, 0x5f, 0x75, 0x6e, 0x69, 0x74, 0x18, 0x05, 0x20, 0x01, 0x28, 0x09,
	0x52, 0x0b, 0x70, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x55, 0x6e, 0x69, 0x74, 0x12, 0x52, 0x0a,
	0x10, 0x70, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x5f, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e,
	0x73, 0x18, 0x06, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78,
	0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x62, 0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x2e, 0x76,
	0x31, 0x2e, 0x50, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e,
	0x52, 0x0f, 0x70, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e,
	0x73, 0x22, 0xf1, 0x01, 0x0a, 0x0e, 0x50, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x56, 0x65, 0x72,
	0x73, 0x69, 0x6f, 0x6e, 0x12, 0x3f, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x0e, 0x32, 0x2b, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75,
	0x64, 0x2e, 0x62, 0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x2e, 0x76, 0x31, 0x2e, 0x50, 0x72, 0x69,
	0x63, 0x69, 0x6e, 0x67, 0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x52,
	0x04, 0x74, 0x79, 0x70, 0x65, 0x12, 0x41, 0x0a, 0x0e, 0x65, 0x66, 0x66, 0x65, 0x63, 0x74, 0x69,
	0x76, 0x65, 0x5f, 0x74, 0x69, 0x6d, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e,
	0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e,
	0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x0d, 0x65, 0x66, 0x66, 0x65, 0x63,
	0x74, 0x69, 0x76, 0x65, 0x54, 0x69, 0x6d, 0x65, 0x12, 0x5b, 0x0a, 0x13, 0x70, 0x72, 0x69, 0x63,
	0x69, 0x6e, 0x67, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x18,
	0x03, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63,
	0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x62, 0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x2e, 0x76, 0x31, 0x2e,
	0x50, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x12, 0x70, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x73, 0x22, 0x48, 0x0a, 0x11, 0x50, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x33, 0x0a, 0x05, 0x72, 0x61,
	0x74, 0x65, 0x73, 0x18, 0x02, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x79, 0x61, 0x6e, 0x64,
	0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x62, 0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67,
	0x2e, 0x76, 0x31, 0x2e, 0x52, 0x61, 0x74, 0x65, 0x52, 0x05, 0x72, 0x61, 0x74, 0x65, 0x73, 0x22,
	0x77, 0x0a, 0x04, 0x52, 0x61, 0x74, 0x65, 0x12, 0x34, 0x0a, 0x16, 0x73, 0x74, 0x61, 0x72, 0x74,
	0x5f, 0x70, 0x72, 0x69, 0x63, 0x69, 0x6e, 0x67, 0x5f, 0x71, 0x75, 0x61, 0x6e, 0x74, 0x69, 0x74,
	0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x14, 0x73, 0x74, 0x61, 0x72, 0x74, 0x50, 0x72,
	0x69, 0x63, 0x69, 0x6e, 0x67, 0x51, 0x75, 0x61, 0x6e, 0x74, 0x69, 0x74, 0x79, 0x12, 0x1d, 0x0a,
	0x0a, 0x75, 0x6e, 0x69, 0x74, 0x5f, 0x70, 0x72, 0x69, 0x63, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x09, 0x52, 0x09, 0x75, 0x6e, 0x69, 0x74, 0x50, 0x72, 0x69, 0x63, 0x65, 0x12, 0x1a, 0x0a, 0x08,
	0x63, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x63, 0x79, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x08,
	0x63, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x63, 0x79, 0x2a, 0x60, 0x0a, 0x12, 0x50, 0x72, 0x69, 0x63,
	0x69, 0x6e, 0x67, 0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x12, 0x24,
	0x0a, 0x20, 0x50, 0x52, 0x49, 0x43, 0x49, 0x4e, 0x47, 0x5f, 0x56, 0x45, 0x52, 0x53, 0x49, 0x4f,
	0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49,
	0x45, 0x44, 0x10, 0x00, 0x12, 0x10, 0x0a, 0x0c, 0x53, 0x54, 0x52, 0x45, 0x45, 0x54, 0x5f, 0x50,
	0x52, 0x49, 0x43, 0x45, 0x10, 0x01, 0x12, 0x12, 0x0a, 0x0e, 0x43, 0x4f, 0x4e, 0x54, 0x52, 0x41,
	0x43, 0x54, 0x5f, 0x50, 0x52, 0x49, 0x43, 0x45, 0x10, 0x02, 0x42, 0x62, 0x0a, 0x1b, 0x79, 0x61,
	0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x61, 0x70, 0x69, 0x2e, 0x62,
	0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x2e, 0x76, 0x31, 0x5a, 0x43, 0x67, 0x69, 0x74, 0x68, 0x75,
	0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2d, 0x63, 0x6c, 0x6f,
	0x75, 0x64, 0x2f, 0x67, 0x6f, 0x2d, 0x67, 0x65, 0x6e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x2f, 0x79,
	0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x62, 0x69, 0x6c, 0x6c,
	0x69, 0x6e, 0x67, 0x2f, 0x76, 0x31, 0x3b, 0x62, 0x69, 0x6c, 0x6c, 0x69, 0x6e, 0x67, 0x62, 0x06,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_yandex_cloud_billing_v1_sku_proto_rawDescOnce sync.Once
	file_yandex_cloud_billing_v1_sku_proto_rawDescData = file_yandex_cloud_billing_v1_sku_proto_rawDesc
)

func file_yandex_cloud_billing_v1_sku_proto_rawDescGZIP() []byte {
	file_yandex_cloud_billing_v1_sku_proto_rawDescOnce.Do(func() {
		file_yandex_cloud_billing_v1_sku_proto_rawDescData = protoimpl.X.CompressGZIP(file_yandex_cloud_billing_v1_sku_proto_rawDescData)
	})
	return file_yandex_cloud_billing_v1_sku_proto_rawDescData
}

var file_yandex_cloud_billing_v1_sku_proto_enumTypes = make([]protoimpl.EnumInfo, 1)
var file_yandex_cloud_billing_v1_sku_proto_msgTypes = make([]protoimpl.MessageInfo, 4)
var file_yandex_cloud_billing_v1_sku_proto_goTypes = []interface{}{
	(PricingVersionType)(0),       // 0: yandex.cloud.billing.v1.PricingVersionType
	(*Sku)(nil),                   // 1: yandex.cloud.billing.v1.Sku
	(*PricingVersion)(nil),        // 2: yandex.cloud.billing.v1.PricingVersion
	(*PricingExpression)(nil),     // 3: yandex.cloud.billing.v1.PricingExpression
	(*Rate)(nil),                  // 4: yandex.cloud.billing.v1.Rate
	(*timestamppb.Timestamp)(nil), // 5: google.protobuf.Timestamp
}
var file_yandex_cloud_billing_v1_sku_proto_depIdxs = []int32{
	2, // 0: yandex.cloud.billing.v1.Sku.pricing_versions:type_name -> yandex.cloud.billing.v1.PricingVersion
	0, // 1: yandex.cloud.billing.v1.PricingVersion.type:type_name -> yandex.cloud.billing.v1.PricingVersionType
	5, // 2: yandex.cloud.billing.v1.PricingVersion.effective_time:type_name -> google.protobuf.Timestamp
	3, // 3: yandex.cloud.billing.v1.PricingVersion.pricing_expressions:type_name -> yandex.cloud.billing.v1.PricingExpression
	4, // 4: yandex.cloud.billing.v1.PricingExpression.rates:type_name -> yandex.cloud.billing.v1.Rate
	5, // [5:5] is the sub-list for method output_type
	5, // [5:5] is the sub-list for method input_type
	5, // [5:5] is the sub-list for extension type_name
	5, // [5:5] is the sub-list for extension extendee
	0, // [0:5] is the sub-list for field type_name
}

func init() { file_yandex_cloud_billing_v1_sku_proto_init() }
func file_yandex_cloud_billing_v1_sku_proto_init() {
	if File_yandex_cloud_billing_v1_sku_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_yandex_cloud_billing_v1_sku_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Sku); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_yandex_cloud_billing_v1_sku_proto_msgTypes[1].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*PricingVersion); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_yandex_cloud_billing_v1_sku_proto_msgTypes[2].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*PricingExpression); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_yandex_cloud_billing_v1_sku_proto_msgTypes[3].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Rate); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_yandex_cloud_billing_v1_sku_proto_rawDesc,
			NumEnums:      1,
			NumMessages:   4,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_yandex_cloud_billing_v1_sku_proto_goTypes,
		DependencyIndexes: file_yandex_cloud_billing_v1_sku_proto_depIdxs,
		EnumInfos:         file_yandex_cloud_billing_v1_sku_proto_enumTypes,
		MessageInfos:      file_yandex_cloud_billing_v1_sku_proto_msgTypes,
	}.Build()
	File_yandex_cloud_billing_v1_sku_proto = out.File
	file_yandex_cloud_billing_v1_sku_proto_rawDesc = nil
	file_yandex_cloud_billing_v1_sku_proto_goTypes = nil
	file_yandex_cloud_billing_v1_sku_proto_depIdxs = nil
}
