// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.28.0
// 	protoc        v3.17.3
// source: yandex/cloud/mdb/elasticsearch/v1/config/elasticsearch.proto

package elasticsearch

import (
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	wrapperspb "google.golang.org/protobuf/types/known/wrapperspb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// Elasticsearch 7.x supported configuration options are listed here.
//
// Detailed description for each set of options is available in [Elasticsearch documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/index.html).
//
// Any options that are not listed here are not supported.
type ElasticsearchConfig7 struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// The maximum number of clauses a boolean query can contain.
	//
	// The limit is in place to prevent searches from becoming too large and taking up too much CPU and memory.
	// It affects not only Elasticsearch's `bool` query, but many other queries that are implicitly converted to `bool` query by Elastcsearch.
	//
	// Default value: `1024`.
	//
	// See in-depth description in [Elasticsearch documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-settings.html).
	MaxClauseCount *wrapperspb.Int64Value `protobuf:"bytes,3,opt,name=max_clause_count,json=maxClauseCount,proto3" json:"max_clause_count,omitempty"`
	// The maximum percentage or absolute value (10%, 512mb) of heap space that is allocated to field data cache.
	//
	// All the field values that are placed in this cache, get loaded to memory in order to provide fast document based access to those values.
	// Building the field data cache for a field can be an expensive operations, so its recommended to have enough memory for this cache, and to keep it loaded.
	//
	// Default value: unbounded.
	//
	// See in-depth description in [Elasticsearch documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/modules-fielddata.html).
	FielddataCacheSize string `protobuf:"bytes,4,opt,name=fielddata_cache_size,json=fielddataCacheSize,proto3" json:"fielddata_cache_size,omitempty"`
	// Remote hosts for reindex have to be explicitly allowed in elasticsearch.yml using the reindex.remote.whitelist property.
	// It can be set to a comma delimited list of allowed remote host and port combinations.
	// Scheme is ignored, only the host and port are used.
	ReindexRemoteWhitelist string `protobuf:"bytes,6,opt,name=reindex_remote_whitelist,json=reindexRemoteWhitelist,proto3" json:"reindex_remote_whitelist,omitempty"`
	// List of paths to PEM encoded certificate files that should be trusted.
	//
	// See in-depth description in [Elasticsearch documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-reindex.html#reindex-ssl)
	ReindexSslCaPath string `protobuf:"bytes,7,opt,name=reindex_ssl_ca_path,json=reindexSslCaPath,proto3" json:"reindex_ssl_ca_path,omitempty"`
}

func (x *ElasticsearchConfig7) Reset() {
	*x = ElasticsearchConfig7{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *ElasticsearchConfig7) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ElasticsearchConfig7) ProtoMessage() {}

func (x *ElasticsearchConfig7) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ElasticsearchConfig7.ProtoReflect.Descriptor instead.
func (*ElasticsearchConfig7) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescGZIP(), []int{0}
}

func (x *ElasticsearchConfig7) GetMaxClauseCount() *wrapperspb.Int64Value {
	if x != nil {
		return x.MaxClauseCount
	}
	return nil
}

func (x *ElasticsearchConfig7) GetFielddataCacheSize() string {
	if x != nil {
		return x.FielddataCacheSize
	}
	return ""
}

func (x *ElasticsearchConfig7) GetReindexRemoteWhitelist() string {
	if x != nil {
		return x.ReindexRemoteWhitelist
	}
	return ""
}

func (x *ElasticsearchConfig7) GetReindexSslCaPath() string {
	if x != nil {
		return x.ReindexSslCaPath
	}
	return ""
}

// Elasticsearch 7.x data node configuration.
type ElasticsearchConfigSet7 struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Effective settings for an Elasticsearch cluster (a combination of settings defined in [user_config] and [default_config]).
	EffectiveConfig *ElasticsearchConfig7 `protobuf:"bytes,1,opt,name=effective_config,json=effectiveConfig,proto3" json:"effective_config,omitempty"`
	// User-defined settings for an Elasticsearch cluster.
	UserConfig *ElasticsearchConfig7 `protobuf:"bytes,2,opt,name=user_config,json=userConfig,proto3" json:"user_config,omitempty"`
	// Default settings for an Elasticsearch cluster.
	DefaultConfig *ElasticsearchConfig7 `protobuf:"bytes,3,opt,name=default_config,json=defaultConfig,proto3" json:"default_config,omitempty"`
}

func (x *ElasticsearchConfigSet7) Reset() {
	*x = ElasticsearchConfigSet7{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *ElasticsearchConfigSet7) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ElasticsearchConfigSet7) ProtoMessage() {}

func (x *ElasticsearchConfigSet7) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ElasticsearchConfigSet7.ProtoReflect.Descriptor instead.
func (*ElasticsearchConfigSet7) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescGZIP(), []int{1}
}

func (x *ElasticsearchConfigSet7) GetEffectiveConfig() *ElasticsearchConfig7 {
	if x != nil {
		return x.EffectiveConfig
	}
	return nil
}

func (x *ElasticsearchConfigSet7) GetUserConfig() *ElasticsearchConfig7 {
	if x != nil {
		return x.UserConfig
	}
	return nil
}

func (x *ElasticsearchConfigSet7) GetDefaultConfig() *ElasticsearchConfig7 {
	if x != nil {
		return x.DefaultConfig
	}
	return nil
}

var File_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto protoreflect.FileDescriptor

var file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDesc = []byte{
	0x0a, 0x3c, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x6d,
	0x64, 0x62, 0x2f, 0x65, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68,
	0x2f, 0x76, 0x31, 0x2f, 0x63, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x2f, 0x65, 0x6c, 0x61, 0x73, 0x74,
	0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x28,
	0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6d, 0x64, 0x62,
	0x2e, 0x65, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x2e, 0x76,
	0x31, 0x2e, 0x63, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x1a, 0x1e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65,
	0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2f, 0x77, 0x72, 0x61, 0x70, 0x70, 0x65,
	0x72, 0x73, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a, 0x1d, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78,
	0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x76, 0x61, 0x6c, 0x69, 0x64, 0x61, 0x74, 0x69, 0x6f,
	0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0xf8, 0x01, 0x0a, 0x14, 0x45, 0x6c, 0x61, 0x73,
	0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x37,
	0x12, 0x45, 0x0a, 0x10, 0x6d, 0x61, 0x78, 0x5f, 0x63, 0x6c, 0x61, 0x75, 0x73, 0x65, 0x5f, 0x63,
	0x6f, 0x75, 0x6e, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x67, 0x6f, 0x6f,
	0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x49, 0x6e, 0x74,
	0x36, 0x34, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x52, 0x0e, 0x6d, 0x61, 0x78, 0x43, 0x6c, 0x61, 0x75,
	0x73, 0x65, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x30, 0x0a, 0x14, 0x66, 0x69, 0x65, 0x6c, 0x64,
	0x64, 0x61, 0x74, 0x61, 0x5f, 0x63, 0x61, 0x63, 0x68, 0x65, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x18,
	0x04, 0x20, 0x01, 0x28, 0x09, 0x52, 0x12, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x64, 0x61, 0x74, 0x61,
	0x43, 0x61, 0x63, 0x68, 0x65, 0x53, 0x69, 0x7a, 0x65, 0x12, 0x38, 0x0a, 0x18, 0x72, 0x65, 0x69,
	0x6e, 0x64, 0x65, 0x78, 0x5f, 0x72, 0x65, 0x6d, 0x6f, 0x74, 0x65, 0x5f, 0x77, 0x68, 0x69, 0x74,
	0x65, 0x6c, 0x69, 0x73, 0x74, 0x18, 0x06, 0x20, 0x01, 0x28, 0x09, 0x52, 0x16, 0x72, 0x65, 0x69,
	0x6e, 0x64, 0x65, 0x78, 0x52, 0x65, 0x6d, 0x6f, 0x74, 0x65, 0x57, 0x68, 0x69, 0x74, 0x65, 0x6c,
	0x69, 0x73, 0x74, 0x12, 0x2d, 0x0a, 0x13, 0x72, 0x65, 0x69, 0x6e, 0x64, 0x65, 0x78, 0x5f, 0x73,
	0x73, 0x6c, 0x5f, 0x63, 0x61, 0x5f, 0x70, 0x61, 0x74, 0x68, 0x18, 0x07, 0x20, 0x01, 0x28, 0x09,
	0x52, 0x10, 0x72, 0x65, 0x69, 0x6e, 0x64, 0x65, 0x78, 0x53, 0x73, 0x6c, 0x43, 0x61, 0x50, 0x61,
	0x74, 0x68, 0x22, 0xd2, 0x02, 0x0a, 0x17, 0x45, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65,
	0x61, 0x72, 0x63, 0x68, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x53, 0x65, 0x74, 0x37, 0x12, 0x6f,
	0x0a, 0x10, 0x65, 0x66, 0x66, 0x65, 0x63, 0x74, 0x69, 0x76, 0x65, 0x5f, 0x63, 0x6f, 0x6e, 0x66,
	0x69, 0x67, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x3e, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65,
	0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6d, 0x64, 0x62, 0x2e, 0x65, 0x6c, 0x61, 0x73,
	0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x2e, 0x76, 0x31, 0x2e, 0x63, 0x6f, 0x6e,
	0x66, 0x69, 0x67, 0x2e, 0x45, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63,
	0x68, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x37, 0x42, 0x04, 0xe8, 0xc7, 0x31, 0x01, 0x52, 0x0f,
	0x65, 0x66, 0x66, 0x65, 0x63, 0x74, 0x69, 0x76, 0x65, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x12,
	0x5f, 0x0a, 0x0b, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x63, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x3e, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c,
	0x6f, 0x75, 0x64, 0x2e, 0x6d, 0x64, 0x62, 0x2e, 0x65, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73,
	0x65, 0x61, 0x72, 0x63, 0x68, 0x2e, 0x76, 0x31, 0x2e, 0x63, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x2e,
	0x45, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x43, 0x6f, 0x6e,
	0x66, 0x69, 0x67, 0x37, 0x52, 0x0a, 0x75, 0x73, 0x65, 0x72, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67,
	0x12, 0x65, 0x0a, 0x0e, 0x64, 0x65, 0x66, 0x61, 0x75, 0x6c, 0x74, 0x5f, 0x63, 0x6f, 0x6e, 0x66,
	0x69, 0x67, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x3e, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65,
	0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6d, 0x64, 0x62, 0x2e, 0x65, 0x6c, 0x61, 0x73,
	0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x2e, 0x76, 0x31, 0x2e, 0x63, 0x6f, 0x6e,
	0x66, 0x69, 0x67, 0x2e, 0x45, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63,
	0x68, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x37, 0x52, 0x0d, 0x64, 0x65, 0x66, 0x61, 0x75, 0x6c,
	0x74, 0x43, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x42, 0x8a, 0x01, 0x0a, 0x2c, 0x79, 0x61, 0x6e, 0x64,
	0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x61, 0x70, 0x69, 0x2e, 0x6d, 0x64, 0x62,
	0x2e, 0x65, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x2e, 0x76,
	0x31, 0x2e, 0x63, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x5a, 0x5a, 0x67, 0x69, 0x74, 0x68, 0x75, 0x62,
	0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2d, 0x63, 0x6c, 0x6f, 0x75,
	0x64, 0x2f, 0x67, 0x6f, 0x2d, 0x67, 0x65, 0x6e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x2f, 0x79, 0x61,
	0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x6d, 0x64, 0x62, 0x2f, 0x65,
	0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65, 0x61, 0x72, 0x63, 0x68, 0x2f, 0x76, 0x31, 0x2f,
	0x63, 0x6f, 0x6e, 0x66, 0x69, 0x67, 0x3b, 0x65, 0x6c, 0x61, 0x73, 0x74, 0x69, 0x63, 0x73, 0x65,
	0x61, 0x72, 0x63, 0x68, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescOnce sync.Once
	file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescData = file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDesc
)

func file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescGZIP() []byte {
	file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescOnce.Do(func() {
		file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescData = protoimpl.X.CompressGZIP(file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescData)
	})
	return file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDescData
}

var file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes = make([]protoimpl.MessageInfo, 2)
var file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_goTypes = []interface{}{
	(*ElasticsearchConfig7)(nil),    // 0: yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfig7
	(*ElasticsearchConfigSet7)(nil), // 1: yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfigSet7
	(*wrapperspb.Int64Value)(nil),   // 2: google.protobuf.Int64Value
}
var file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_depIdxs = []int32{
	2, // 0: yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfig7.max_clause_count:type_name -> google.protobuf.Int64Value
	0, // 1: yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfigSet7.effective_config:type_name -> yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfig7
	0, // 2: yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfigSet7.user_config:type_name -> yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfig7
	0, // 3: yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfigSet7.default_config:type_name -> yandex.cloud.mdb.elasticsearch.v1.config.ElasticsearchConfig7
	4, // [4:4] is the sub-list for method output_type
	4, // [4:4] is the sub-list for method input_type
	4, // [4:4] is the sub-list for extension type_name
	4, // [4:4] is the sub-list for extension extendee
	0, // [0:4] is the sub-list for field type_name
}

func init() { file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_init() }
func file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_init() {
	if File_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*ElasticsearchConfig7); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes[1].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*ElasticsearchConfigSet7); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDesc,
			NumEnums:      0,
			NumMessages:   2,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_goTypes,
		DependencyIndexes: file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_depIdxs,
		MessageInfos:      file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_msgTypes,
	}.Build()
	File_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto = out.File
	file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_rawDesc = nil
	file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_goTypes = nil
	file_yandex_cloud_mdb_elasticsearch_v1_config_elasticsearch_proto_depIdxs = nil
}
